#include <stdio.h>
#include <sys/time.h>
#include <stdint.h>

/* The gettimeofday invocations are handled efficiently in userspace
   (vsyscall). */

/* No need to address overflow here as the maximum is 10 s */
uint32_t difftv (struct timeval *before, struct timeval *after) {
  return 1000000 * (after->tv_sec - before->tv_sec)
    + after->tv_usec - before->tv_usec;
}

int main () {
  struct timeval before, after;
  if (gettimeofday(&before, NULL) != 0) {
    perror("gettimeofday");
    return -1;
  }
  after = before;
  while (difftv(&before,&after) < 10000000)
    if (gettimeofday(&after, NULL) != 0) {
      perror("gettimeofday");
      return -1;
    }
  return 0;
}
