#!/usr/bin/ruby
# Compute the aliquot sequence beginning with the number supplied on the
# command line (parallel implementation).

require 'parallel'

if ARGV.length==2
  n = ARGV[0].to_i
  numprocs = ARGV[1].to_i
else
  puts "Usage: aliquot N numprocs"
  exit
end

# Sum of divisors function (parallel implementation).
def sigma(n_in,numprocs)
  throw "Bad value" if n_in < 1
  limit = Math.sqrt(n_in).floor
  Parallel.in_processes(:count=>numprocs){|procnum|
    n_out = 0
    (1+procnum..limit).step(numprocs).each{|i|
      if n_in % i == 0
	j = n_in/i
	n_out += i
	n_out += j if j!=i
      end
    }
    n_out
  }.inject(:+)
end

seenvals = Array.new
itercount = 1
print itercount, " ", n, "\n"
while n>0 && seenvals.index(n).nil?
  seenvals.push(n)
  n = sigma(n,numprocs)-n
  itercount += 1
  print itercount, " ", n, "\n"
end
print "Cycle of length ", itercount-seenvals.index(n)-1, " detected.\n" if n>0
