# Rscript this and the output goes to Rplots.pdf.

options(warn=1)
data <- read.table("0-data.txt",header=T,colClasses="numeric")

doplot <- function(data,os,workload,depvar) {
  y <- data[data$workload==workload & data$os==os,depvar]
  if (sum(!is.na(y)) > 0) {
    caption <- sprintf("os=%d workload=%d depvar %s", os, workload, colnames(data)[depvar])
    plot(y,main=caption)
    if (var(y) > 0)
      plot(density(y),main=caption)
    # This just makes it worse: density(y,bw="bcv")
  }
}

for (os in 0:1) {
  for (workload in unique(data$workload)) {
    for (depvar in 3:ncol(data)) {
      doplot(data,os,workload,depvar)
    }
  }
}
