#!/usr/bin/ruby

require 'GECS'

# Convert initial R tables to GECS.

filecontent = File.open("data.txt").read
data = filecontent.scan(/.*\n/).map(&:split)
datacnam = data[0]   # First row is column names
data = data[1..-1]   # Numbers stored as strings
data.map!{|a| [a[0].to_i, a[1].to_f, a[2].to_f, a[3].to_f]}

filecontent = File.open("blocks.txt").read
blocks = filecontent.scan(/.*\n/).map(&:split)
blockscnam = blocks[0]   # First row is column names
blocks = blocks[1..-1]   # Numbers stored as strings
blocks.map!{|a| a.map{|n| n.to_i}}

bag = GECS.load("../0-metrics/screening.gecs")

# day is not balanced, so don't include it as a factor.

id = 1
experiment = GECS::Experiment.new(id,
  ["block","os"],
  ["bash-elapsed", "bash-user", "bash-sys"],
  "Boot dependency experiment")
results = Hash.new
for block in 1..20
  raise "Blockhead" if blocks[block-1][0] != block
  raise "Nil fail 0" if blocks[block-1][0].nil?
  raise "Nil fail 1" if blocks[block-1][1].nil?
  raise "Nil fail 2" if blocks[block-1][2].nil?
  result = Array.new(3)
  for depvar in 1..3
    result[depvar-1] = data.select{|x| x[0]==block}.map{|a| a[depvar]}
  end
  results[GECS::Key.new(id,[block,
                            blocks[block-1][1]])] = result
end

bag.experiments.push(experiment)
bag.data.merge!(results)

# print "Bootstrapping experiment\n"
# GECS.bootstrapMeans(bag,id,[0.001,0.001,0.00001])
print "Dumping experiment\n"
File.open(id.to_s + "-data.txt","w"){|fp| fp << GECS::dumpData(bag,id)}
# File.open(id.to_s + "-parms.txt","w"){|fp| fp << GECS::dumpParms(bag,id,true)}
GECS.save("screening.gecs",bag)
