#!/usr/bin/ruby
puts Time.now.to_s + "  Start"
perf = "perf record -q -e cpu-cycles -c 1000000 -o /tmp/perf_data --call-graph"
cmds = Array.new(6)
cmds[0] = "{ time               ./aliquot   10000000; } >/dev/null 2>>log00.txt"
cmds[1] = "{ time #{perf} dwarf ./aliquot   10000000; } >/dev/null 2>>log01.txt"
cmds[2] = "{ time #{perf} fp    ./aliquot   10000000; } >/dev/null 2>>log02.txt"
cmds[3] = "{ time               ./aliquotfp 10000000; } >/dev/null 2>>log10.txt"
cmds[4] = "{ time #{perf} dwarf ./aliquotfp 10000000; } >/dev/null 2>>log11.txt"
cmds[5] = "{ time #{perf} fp    ./aliquotfp 10000000; } >/dev/null 2>>log12.txt"
# Since we are only interested in the event count, we don't need the verbosity
# of a full callchains report.  -s dso -g none gets a very concise report.
rept = "perf report -i /tmp/perf_data -s dso -g none"
repts = Array.new(6)
repts[1] = "#{rept} >> rep01.txt"
repts[2] = "#{rept} >> rep02.txt"
repts[4] = "#{rept} >> rep11.txt"
repts[5] = "#{rept} >> rep12.txt"
for i in 1..5000
  print "\nIteration ", i, "\n"
  for j in Array(0..5).shuffle
    puts cmds[j]
    system(cmds[j])
    unless repts[j].nil?
      puts repts[j]
      system(repts[j])
      File.delete("/tmp/perf_data")
    end
  end
end
puts Time.now.to_s + "  Done"
