# Rscript this and the output goes to Rplots.pdf.

options(warn=1)
data <- read.table("2-data.txt",header=T,colClasses="numeric")

doplot <- function(data,os,fp,prf,depvar) {
  y <- data[data$os==os & data$fp==fp & data$prf==prf,depvar]
  if (sum(!is.na(y)) > 0) {
    caption <- sprintf("os=%d fp=%d prf=%d depvar %s", os,fp,prf, colnames(data)[depvar])
    plot(y,main=caption)
    if (var(y) > 0)
      plot(density(y),main=caption)
  }
}

for (os in 0:1) {
  for (fp in 0:1) {
    for (prf in 0:2) {
      for (depvar in 4:ncol(data)) {
	doplot(data,os,fp,prf,depvar)
      }
    }
  }
}
