#!/usr/bin/ruby

# FIXME:  Should have done the extra math in materiality.R.
# It only outputs the mean and median.

# qnorm(0.975)
K = 1.9599639845400536

def convert_subdir(bca,outfile)
  for i in [5, 10, 20, 40, 80, 160, 320, 640, 1280]
    fnam = (bca==0 ? "materiality-original" : "materiality-BCa") + "/materiality" + i.to_s + ".log"
    thefile = File.open(fnam).read
    attcov = thefile.scan(/Attained coverage = ([\d\.]*)/).flatten[0].to_f
    attu = K*Math.sqrt(attcov*(1.0-attcov)/15000.0)
    mean = thefile.scan(/All interval widths mean = ([\d\.]*)/).flatten[0].to_f
    widths = thefile.scan(/width ([\d\.]*)/).flatten.map{|x| x.to_f}.sort
    throw "Wrong length" if widths.length != 15000
    # The R quantile function is more sophisticated than this.
    q1 = widths[3749]
    q2 = (widths[7499] + widths[7500]) / 2.0
    q3 = widths[11250]
    outfile.print bca, " ", i, " ", attcov, " ", attu, " ", mean, " ", q1, " ", q2, " ", q3, "\n"
  end
end

File.open("data.txt","w") do |outfile|
  outfile.puts "BCa subsamp attcov attu mean q1 q2 q3"
  convert_subdir(0,outfile)
  convert_subdir(1,outfile)
end
