# 2014-06-09 16:59

# Subsample size.
args <- commandArgs(trailingOnly=T)
subsamp <- as.numeric(args[1])

# Number of subsamples to take to get the averages.
N <- 15000

library('bootBCa')
data <- read.table("../../1-data.txt",header=T,colClasses="numeric")
data <- data[data$os==1 & data$fp==0 & data$prf==0,5]
realmean <- mean(data)
cat(sprintf("Mean of %d data = %f\n", length(data), realmean))

widths <- rep(NA,N)
hits <- widths
for (i in 1:N) {
  data2 <- sample(data,subsamp,replace=F)
  out <- BCa(x=data2,delta=NA,M=50000,theta=mean)
  cat(sprintf("Iteration %d, reps %d, width %f, ", i, out[1], out[5]-out[4]))
  widths[i] <- out[5]-out[4]
  hits[i] <- (out[4] <= realmean & realmean <= out[5])
  cat(ifelse(hits[i],"hit\n","miss\n"))
}

cat(sprintf("Attained coverage = %f\n", sum(hits)/N))
cat(sprintf("All interval widths mean = %f, median = %f\n",
  mean(widths), median(widths)))
cat(sprintf("Successful interval widths mean = %f, median = %f\n",
  mean(widths[hits]), median(widths[hits])))
