# 2014-05-21 13:34

# Subsample size.
args <- commandArgs(trailingOnly=T)
subsamp <- as.numeric(args[1])

# Number of subsamples to take to get the averages.
N <- 15000

data <- read.table("../../1-data.txt",header=T,colClasses="numeric")
data <- data[data$os==1 & data$fp==0 & data$prf==0,5]
realmean <- mean(data)
cat(sprintf("Mean of %d data = %f\n", length(data), realmean))

widths <- rep(NA,N)
hits <- widths
for (i in 1:N) {
  data2 <- sample(data,subsamp,replace=F)

  mean <- mean(data2)
  # var uses denominator n-1.
  U <- sqrt(var(data2)/subsamp) * qt(0.975,subsamp-1)
  meanlo <- mean - U
  meanhi <- mean + U

  cat(sprintf("Iteration %d, width %f, ", i, meanhi-meanlo))
  widths[i] <- meanhi-meanlo
  hits[i] <- (meanlo <= realmean & realmean <= meanhi)
  cat(ifelse(hits[i],"hit\n","miss\n"))
}

cat(sprintf("Attained coverage = %f\n", sum(hits)/N))
cat(sprintf("All interval widths mean = %f, median = %f\n",
  mean(widths), median(widths)))
cat(sprintf("Successful interval widths mean = %f, median = %f\n",
  mean(widths[hits]), median(widths[hits])))
